// Devera ser criada a variavel de ambiente WKSNET
// Essa variavel pode ser criada no AUTOEXEC.BAT ou no arquivo de lote
// que chama o sistema. Para criar a variavel use :
// SET WKSNET=001
//
// Regras para a criacao da variavel :
// 1 - Devera ser um valor entre 001 e 999
// 2 - Devera ser atribuida em todos os computadores da rede (inclusive no
//     servidor)
//
//


PUBLIC ESTACAO,VA,EM_USO,FORA_USO
CLS
IF TRAVAJAN()=.F.
   RETURN
ENDIF

GET1:= GET2:= GET3:= SPACE(50)
GET4:=0
@ 02,00 SAY "ESTACAO -> "+ESTACAO
DO WHIL .T.
   GET1:= GET2:= GET3:= SPACE(50)
   @ 05,00 SAY "NOME       -> " GET GET1 PICT "@!"
   @ 06,00 SAY "ENDERECO   -> " GET GET2 PICT "@!"
   @ 07,00 SAY "E-MAIL     -> " GET GET3 PICT "@!"
   @ 08,00 SAY "NESTACOES -> " GET GET4 PICT "999" VALID GET4>0
   READ
   IF LASTKEY()=27
      FCLOSE(VA)                  //Isto nao e exatamente necessario,
      FERASE("CONTROLE."+ESTACAO) //mas, seria bom se fosse usado.
      CLS
      RETURN(.T.)
   ENDIF
   IF GET4=0
      GET4=10
   ENDIF
   TOTUSO=VERIFWKS(GET4)
   @ 15,00 SAY "EM USO   -> "+STR(TOTUSO,3)
   @ 16,00 SAY "FORA USO -> "+STR(GET4-TOTUSO,3)
   INKEY(0)
   @ 15,00 CLEAR TO 16,79
ENDDO

** Abaixo seguem as funcoes que realmente interessam - O codigo acima
** serve apenas como exemplo de uso das funcoes abaixo

*-----------------* // Esta funcao verifica se o sistema ja esta sendo 
 FUNCTION TRAVAJAN  // Utilizado na estacao corrente
*-----------------* // Desta forma, nao permite 2 Janelas.
                    // Verifica ainda se esta estabelecida a variavel de
                    // ambiente WKSNET e se ela e valida
                    // Retorna .T. se tudo ok e .F. se houver problemas
IF LEN(ALLTRIM(GETENV("WKSNET")))=0
   @ 02,00 SAY "Estacao nao configurada no AUTOEXEC.BAT. Verifique !!!"
   @ 05,00 SAY REPLICATE("=",54)
   INKEY(0)
   RETURN(.F.)
ENDIF
IF VAL(GETENV("WKSNET"))<1 .OR. VAL(GETENV("WKSNET"))>999 .OR.;
   LEN(ALLTRIM(GETENV("WKSNET")))<>3
   @ 02,00 SAY "Valor invalido - WKSNET no AUTOEXEC.BAT. Verifique !!!"
   @ 03,00 SAY "Valor WKSNET -> "+GETENV("WKSNET")
   @ 05,00 SAY REPLICATE("=",54)
   INKEY(0)
   RETURN(.F.)
ENDIF

ESTACAO=GETENV("WKSNET")
FERASE("CONTROLE."+ESTACAO)
VA=FCREATE("CONTROLE."+ESTACAO,0)
FWRITE(VA,"[ Arquivo de Controle do Sistema ]")
FCLOSE(VA)
VB=FOPEN("CONTROLE."+ESTACAO,50)

IF FERROR()<>0
   CLS
   @ 02,00 SAY "O Sistema ja esta sendo executado nesta estacao - "+ESTACAO
   @ 03,00 SAY STRZERO(FERROR(),3)
   @ 04,00 SAY STRZERO(VA,3)
   @ 05,00 SAY REPLICATE("=",50)
   INKEY(0)
   RETURN(.F.)
ENDIF
RETURN(.T.)

**---------------------- Fim da funcao TRAVAJAN
**---------------------------------------------

*-------------------------* // Esta funcao retorna quantas estacoes estao
 FUNCTION VERIFWKS(TOTWKS)  // Utlizando o sistema no momento
*-------------------------* // Recebe como parametro a qtd. de estacoes
EM_USO=0                    // da rede que usam o sistema
FOR CONTA=1 TO TOTWKS
    IF FILE("CONTROLE."+STRZERO(CONTA,3))
       VB=FOPEN("CONTROLE."+ESTACAO,50)
       IF FERROR()<>0
          EM_USO++
       ELSE
          FCLOSE(VB)
       ENDIF
    ENDIF
NEXT
RETURN(EM_USO)

**---------------------- Fim da funcao VERIFWKS
**---------------------------------------------
